#include <bits/stdc++.h>
using namespace std;

const int MOD = 666013;

void Merge(set<int> &a, set<int> &b) {
  if (a.size() < b.size()) swap(a, b);
  for (int x : b) {
    auto it = a.find(x);
    if (it == a.end()) a.emplace(x);
    else a.erase(it);
  }
}

set<int> DFS(int node, int par, vector<int64_t> &count, vector<int> &weight,
  const vector<vector<int>> &pairs, const vector<vector<pair<int, int>>> &adj) {
  set<int> s(pairs[node].begin(), pairs[node].end());
  for (auto &p : adj[node]) {
    int x, w; tie(x, w) = p;
    if (x == par) continue;

    weight[x] = w;
    auto child = DFS(x, node, count, weight, pairs, adj);
    Merge(s, child);
  }
  count[node] = s.size();
  return s;
}

int main() {
  ifstream cin("amazon.in");
  ofstream cout("amazon.out");

  int n; cin >> n;
  vector<vector<pair<int, int>>> adj(n);
  for (int i = 0; i < n - 1; ++i) {
    int x, y, w; cin >> x >> y >> w;
    adj[x].emplace_back(y, w);
    adj[y].emplace_back(x, w);
  }

  int m, k; cin >> m >> k;
  vector<vector<int>> pairs(n);
  for (int i = 0; i < m; ++i) {
    int x, y; cin >> x >> y;
    pairs[x].emplace_back(i);
    pairs[y].emplace_back(i);
  }

  vector<int64_t> count(n);
  vector<int> weight(n);
  DFS(0, -1, count, weight, pairs, adj);

  vector<int> order(n - 1);
  iota(order.begin(), order.end(), 1);
  sort(order.begin(), order.end(), [&](int a, int b) {
    return count[a] > count[b];
  });

  int ans = 0;
  for (int node : order) {
    if (k > 0) {
      int sub = min(k, weight[node]);
      weight[node] -= sub;
      k -= sub;
    }

    ans += 1LL * weight[node] * count[node] % MOD;
    if (ans >= MOD) ans -= MOD;
  }
  
  cout << ans << endl;
}
